# Managing Streams A stream is a logical entity created through the Stream Management APIs. It allows you to organize telemetry data from assets that share the same set of subscriptions. 1. Create a Stream 2. Subscribe to the Stream. 3. Attach assets to the Stream. 4. (*Optional*) Create alert rules to define specific conditions for triggering notifications or actions based on metrics and event data. ## Limitations[​](#limitations "Direct link to Limitations") Streams have the following limitations: * There is a limit of 5 streams per Project. * You can only attach one Organization to a Stream. * You can only attach 5 Project assets to a Stream. * You can create up to 3 subscriptions per Stream. Each subscription must be for a different sink. * You can attach 50 assets per Stream. * You can create up to 50 Metrics Alert Rules per Stream. ## Prerequisites[​](#prerequisites "Direct link to Prerequisites") * To create streams, you must have the `Fabric Stream Subscription Manager` (STREAM\_SUBSCRIPTION PERMISSION CREATE AND READ) role. Contact your Company Administrator or IAM Administrator to [mange access and roles](https://docs.equinix.com/iam/user-management/iam-users-access-roles.md). * Submit your user credentials, Client ID, and Client Secret for OAuth2 authentication. Refer to [API Authentication](https://docs.equinix.com/equinix-api/api-authentication.md) for more information on how to authenticate your requests to the Equinix API. ## Creating Streams[​](#creating-streams "Direct link to Creating Streams") * Portal * API 1. Log in to the [Customer Portal](https://portal.equinix.com/fabric) > *Fabric Dashboard*. 2. From the *Observability* menu, select **Data Streams**. ![Observability Drop-down Menu Screenshot](https://docs.equinix.com/assets/images/observability-drop-down-7b9fce28b7a44d07b365263f69b94cc2.png) 3. In the *Data Stream Details*, give your stream a name. Optionally, add a description. The *Project ID* is auto-populated with your current Project ID. Use the [*Context Switcher*](https://docs.equinix.com/iam/resources/projects-manage.md#switching-between-projects) to change Projects. ![Creating a Data Stream Dialog Screenshot](https://docs.equinix.com/assets/images/create-data-stream-details-4913afe9c74ee7b82d0daac704bee370.png) 4. Click **Create Data Stream**. Send a `POST` request to the [`/fabric/v4/streams`](https://docs.equinix.com/api-catalog/fabricv4/streams/createstreams.md) endpoint to create a Stream. Sample cURL request: ``` curl -X 'POST' 'https://api.equinix.com/fabric/v4/streams' \ -H 'Content-Type: application/json' \ -H 'Authorization: Bearer ' \ -d '{ "type": "TELEMETRY_STREAM", "name": "splunk1", "description": "subscription 1", "project": { "projectId": "" } }' ``` Sample Response: ``` {     "uuid": "241372e9-79c9-4ef8-b77a-8b8176c2098b4",     "href": "https://api.equinix.com/fabric/v4/streams/241372e9-79c9-4ef8-b77a-8b8176c228b4",     "type": "TELEMETRY_STREAM",     "name": "splunk1",     "description": "subscription 1",     "project": {         "projectId": ""     },     "enabled": true,     "state": "PROVISIONING",     "assetsCount": 0,     "streamSubscriptionsCount": 0,     "changelog": {         "createdBy": "testuser",         "createdDateTime": "2024-08-12T21:14:17.689103902Z"     } } ``` ## Viewing Your Streams[​](#viewing-your-streams "Direct link to Viewing Your Streams") * Portal * API 1. Log in to the [Customer Portal](https://portal.equinix.com/fabric) > *Fabric Dashboard*. 2. From the *Observability* menu, select **Data Streams**. The table lists your data streams, their status, how many subscriptions there are to the stream, and how many resources you added to the stream. ![Data Streams List Screenshot](https://docs.equinix.com/assets/images/data-streams-list-e7dd7de22e5da8c72b6e4b630a02019b.png) Click on a *Stream Name* to view its *Stream Details* page, which contains your stream's description and *Activity Log*. ![Stream Detail Screenshot](https://docs.equinix.com/assets/images/data-stream-details-69ab0be48e11475c4dd90a2cc454e18a.png) The *Subscriptions* tab contains the [Subscription List](https://docs.equinix.com/observability/streaming-data/api-managing-subscriptions.md#viewing-your-subscriptions) for subscriptions to this stream, and the *Resources* tab contains the [Resources List](https://docs.equinix.com/observability/streaming-data/api-managing-assets.md#viewing-attached-assets) for the resources added to this stream. To get the details of a Stream, send a `GET` request to the [`/fabric/v4/streams/{stream_id}`](https://docs.equinix.com/api-catalog/fabricv4/streams/getstreambyuuid.md) endpoint. Sample cURL Request: ``` curl -X 'GET' 'https://api.equinix.com/fabric/v4/streams/241372e9-79c9-4ef8-b77a-8b8176c2098b4' \ -H 'Content-Type: application/json' \ -H 'Authorization: Bearer ' ``` Sample Response: ``` {     "href": "https://api.equinix.com/fabric/v4/streams/241372e9-79c9-4ef8-b77a-8b8176c228b4",     "uuid": "241372e9-79c9-4ef8-b77a-8b8176c2098b4",     "type": "STREAM_SUSBSCRIPTION",     "name": "splunk1",     "description": "subscription 1",     "project": {         "projectId": ""     },     "enabled": true,     "state": "PROVISIONED",     "changelog": {         "createdBy": "testuser",         "createdDateTime": "2024-08-12T21:14:17.689104Z"     } } ``` ## Deleting Streams[​](#deleting-streams "Direct link to Deleting Streams") * Portal * API To delete a stream, click on a *Stream Name* to view its *Stream Details* page. From the *Actions* drop-down, click **Delete Data Stream**. ![Deleting a Data Stream Screenshot](https://docs.equinix.com/assets/images/data-stream-delete-c157ff5cb09d94e17a01d0bda6db7f4c.png) In the confirmation box, click **Yes, Delete**. To delete a stream, send a `DELETE` request to the [`/fabric/v4/streams/{stream_id}`](https://docs.equinix.com/api-catalog/fabricv4/streams/deletestreambyuuid.md) endpoint. Sample cURL Request: ``` curl -X 'DELETE' 'https://api.equinix.com/fabric/v4/streams/241372e9-79c9-4ef8-b77a-8b8176c2098b4' \ -H 'Content-Type: application/json' \ -H 'Authorization: Bearer ' ```